
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[poj]1644放苹果 / 憋错料</title>

    <meta name="description" content="[poj]1644放苹果 题目链接:http://poj.org/problem?id=1664 把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5,1,1和1,5,1 是同一种分法. 解题思路: 设f(m,n)为把m个苹果放到n个盘子中的方法数,m&gt;=0,n&gt;=0. 若m和n中任何一个等于0,那么f(m,n) = 1,注意不是等于0,因为相当于就那么一种结果,就是不往盘子里面放(没有苹果),或者,连盘子都没有.若n=1,显然对于任意的m&gt;=0 有f(m, ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[poj]1644放苹果</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>题目链接：<a href="http://poj.org/problem?id=1664" rel="external nofollow noreferrer">http://poj.org/problem?id=1664</a></p>

<p>把M个同样的苹果放在N个同样的盘子里，允许有的盘子空着不放，问共有多少种不同的分法？（用K表示）5，1，1和1，5，1 是同一种分法。</p>

<p>解题思路：</p>
<p>设f(m,n)为把m个苹果放到n个盘子中的方法数，m&gt;=0,n&gt;=0.</p>
<p>若m和n中任何一个等于0，那么f(m,n) = 1，注意不是等于0，因为相当于就那么一种结果，就是不往盘子里面放（没有苹果），或者，连盘子都没有。<br />若n=1,显然对于任意的m&gt;=0 有f(m,1) = 1<br />若m=1,显然对于任意的n&gt;=0 有f(1,n) = 1<br />接下来讨论m&gt;1 &amp;&amp; n&gt;1的情况：<br />若 m &lt; n 则 f(m,n) = f(m,m)。即空哪几个盘子都是一样的</p>
<p>若 m&gt;=n 则 大体有两种放法：</p>
<p>第1种情况：至少有一个盘子为空，即什么也不放，这部分的方法数为f(m,n-1);</p>
<p>第2种情况：全部盘子都有苹果，那么先从m个苹果中抽取出n个出来，各个盘子分一个，考虑剩下的m-n个苹果放到n个盘子里的放法，这样就成功把f(m,n)降到了f(m-n,n)。<br />所以，m&gt;=n时，有f(m,n) = f(m,n-1) + f(m-n,n);</p>

<p>AC代码：</p>
<pre>#include&lt;stdio.h&gt;
int f(int x,int y)
{
    if(y ==1||x==0) return 1;
    if(x&lt;y) return f(x,x);
    return f(x,y-1)+f(x-y,y);//至少一个盘子为空或者每个盘子都放了苹果
}

int main()
{
    int t,m,n,i;
    scanf("%d",&amp;t);
    for(i=0;i&lt;t;i++)
       {
        scanf("%d%d",&amp;m,&amp;n);
        printf("%d\n",f(m,n));
    }
       return 0;
}</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-07 03:30:14 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[poj]1644放苹果的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RjDmv0.html" rel="bookmark">POJ 1644 放苹果 递推 递归</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				放苹果 Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 28356   Accepted: 17939 Description 把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5,1,1和1,5,1 是同一种分法. Input 第一行是测试数据的数目t(0 &lt;= t &lt;= 20).以下每行均包含二个整数M和N,以空格分开.1&lt;=M,N&lt;=10. Output 对			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MznzVqM.html" rel="bookmark">&lbrack;ACM&rsqb; POJ 1664 放苹果（n个相同小球放入m个相同盒子）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				放苹果 Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 25952   Accepted: 16509 Description 把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5,1,1和1,5,1 是同一种分法. Input 第一行是测试数据的数目t(0 &lt;= t &lt;= 20).以下每行均包含二个整数M和N,以空格分开.1&lt;=M,N&lt;=10. Output 对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBamKA4.html" rel="bookmark">poj 1664 放苹果 递归</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接: http://poj.org/problem?id=1664 题目描述: 有n个苹果,m个盒子,盒子和苹果都没有顺序,盒子可以为空,问:有多少种放置方式? 解题思路: 当前有n个苹果,m个盒子. (1):假设当前最少的盒子放置一个苹果,则给m个盒子分别放一个苹果,剩下n-m个苹果. (2):假设当前最少的盒子不放苹果,则剩m-1个box,n个苹果. 代码: 1 #include &lt;cstdio&gt; 2 #include &lt;cstring&gt; 3 #include &lt;c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm16lKM.html" rel="bookmark">poj 1664 放苹果（dfs&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				放苹果 Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 30284   Accepted: 19098 Description 把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5,1,1和1,5,1 是同一种分法. Input 第一行是测试数据的数目t(0 &lt;= t &lt;= 20).以下每行均包含二个整数M和N,以空格分开.1&lt;=M,N&lt;=10. Output 对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qEmjz3.html" rel="bookmark">POJ 1664 放苹果 &lpar;递推&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目链接:http://poj.org/problem?id=1664 dp[i][j]表示i个盘放j个苹果的方案数,dp[i][j] 可以由 dp[i - 1][j] 和 dp[i][j - i] 递推而来. 当盘子的个数大于等于苹果的个数: dp[i - 1][j] :i - 1个盘子放j个苹果,说明i个盘子里最少有一个盘子是空的 dp[i][j - i] :i个盘子都放了苹果,说明有j - i个苹果是随便放置的 否则: dp[i][j] = dp[i - 1][j] 然后没有苹果的盘子的方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41zy9OM.html" rel="bookmark">POJ 1664 放苹果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				传送门:https://i.cnblogs.com/EditPosts.aspx?opt=1 解题思路: m:苹果数量,n:盘子数量. f(m,n):=m个苹果放在n个盘子的方案数 1.n&gt;m 这时总会有有n-m个盘子剩下,这时问题就可以转换到  f(m,m) 2. n&lt;=m 这时有两种情况,每个盘子都放,然后就是把m-n个苹果放入n个盘子  f(m-n,n); 至少有一个盘子不放,那么就是把m个苹果放入n-1个盘子f(m,n-1); 基本情况 只有1个苹果,或0个苹果只有一种情况. 只有一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6DAZr3.html" rel="bookmark">POJ 1664 放苹果【DFS】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题意:给出n个苹果,m个盘子,问有多少种不同的苹果放置方法 可以把它抽象为把一个数n,拆分成a1,a2,a3,---,am,使得它们的和为n, 话说这一题是学习的ppt里面的,它的思路就是搜索 搜索条件的设置:放置苹果到第k个盘子的时候,要求第k个盘子里面的苹果数目大于第k-1个盘子里面的苹果数目,如果大于,则把它放置在第k个盘子里,如果不大于,则继续放置苹果,如果剩下的苹果小于k-1个盘子里面的苹果,就停止这个分支的搜索 学搜索学的还是蒙蒙的--- 这一题如果自己模拟一下样例是怎么搜的,好理解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wWwAQ3.html" rel="bookmark">poj1664 放苹果（递归）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/u012860063?viewmode=contents 题目链接:http://poj.org/problem?id=1664 Description 把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5,1,1和1,5,1 是同一种分法. Input 第一行是测试数据的数目t(0 &lt;= t &lt;= 20).以下每行均包含二个整数M和N,以空格分开.1&lt;=M,N&lt;=10. Out			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n3ZvVm3.html" rel="bookmark">【递归】放苹果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题 : [递归]放苹果 题目描述 楚继光刚把油拿到厨房,老妈又大声喊道:“快去把苹果洗了放到盘子里去.” 楚继光要把M个同样的苹果放在N个同样的盘子里,允许有的盘子空着不放,问共有多少种不同的分法?(用K表示)5.1.1和1.5.1 是同一种分法. 输入 第1行为一个整数,表示测试数据的数目(测试数据的数目t(0 ≤ t ≤20),第2行为M和N(M和N,以空格分开.1≤M,N≤10). 输出 输出有多少种不同分法. 样例输入 1 7 3 样例输出 8 #include &lt;iostream&gt;			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBYnZ4.html" rel="bookmark" class="title">单例模式和工厂模式&lpar;百度文库&rpar;</a>
					<div>
						模式中的单例模式分为:饿汉模式和懒汉模式. 顾名思义: 饿汉模式是对食物(Singleton)比较渴望的,所有一开始就new了一个来满足(食欲) 饿汉式: public class Singleton ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KRawM.html" rel="bookmark" class="title">20160522~20160528</a>
					<div>
						20160523 bzoj2561 http://www.lydsy.com/JudgeOnline/problem.php?id=2561 题意:给定一个连通无向图,假设现在加入一条边权为L的边(u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8Agl3.html" rel="bookmark" class="title">Qt版本中国象棋开发（四）</a>
					<div>
						内容:走法产生 中国象棋基础搜索AI, 极大值,极小值剪枝搜索, 静态估值函数 理论基础: (一)人机博弈走法产生: 先遍历某一方的所有棋子,再遍历整个棋盘,得到每个棋子的所有走棋情况(效率不高,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYNEB3.html" rel="bookmark" class="title">shell简单使用&lpar;五&rpar;变量之三</a>
					<div>
						shell变量处理 1. 变量删除 ${var#key}删除从头开始的最短匹配 ${var##key}删除从头开始的最长匹配 2. 变量删除 ${var%key}删除从尾向前的最短匹配 ${var%% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYj8q0.html" rel="bookmark" class="title">通用分页存储过程</a>
					<div>
						/****** Object: StoredProcedure [dbo].[sp_CommonPaging] Script Date: 08/03/2015 21:06:14 ******/ --通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3882gR3.html" rel="bookmark" class="title">C&sol;C&plus;&plus;心得-理解指针</a>
					<div>
						上一篇笔者用那不是怎么好理解的逻辑介绍了内存和C中的基本数据类型,现在笔者再根据自己重新所学来说说C语言中的指针. 理解指针才能真正的算C语言入门.也许是我大学期间太关注前端UE,也许是当初开始学C语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjQnd3.html" rel="bookmark" class="title">XenServer 主机池</a>
					<div>
						一个资源池由多个 XenServer 主机安装组成,这些主机绑定在一起形成一个托管实体. 资源池允许您将多个服务器及其连接的共享存储视作单个统一资源,并且支持基于其资源需求和业务优先级灵活地部署虚拟机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62ExyM.html" rel="bookmark" class="title">龙果学院基于Dubbo分布式系统架构的第三方支付系统实战教程五一优惠活动</a>
					<div>
						五一特惠,200元免费领!龙果学院&lt;基于Dubbo分布式系统架构实战教程&gt;提前大放“价”:点击分享链接购买即可获得百元现金红包奖励,更多惊喜请点击:http://www.roncoo.co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZrD2g3.html" rel="bookmark" class="title">ios-高德地图的导入</a>
					<div>
						最近在做地图的应用,客户让用高德的地图库,现在总算是完工了,这么一路走来,真是尝尽了酸苦辣啊,网上高德的资源,可以说少之又少,可用资源比大熊猫还少,真让国宝汗颜啊,不得不说一句,珍爱生命,远离..你懂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ML2yVW3.html" rel="bookmark" class="title">PRINCE2价值</a>
					<div>
						大多数人都没有搞清楚&quot;PMP和PRINCE2到底有什么区别?哪个含金量更高?&quot;,接下来~我将根据自己的切身体会,从三个方面回答这个问题,希望共同探讨,对学员朋友带来帮助. 一.认证 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLPWAQM.html" rel="bookmark" class="title">vim 脚本之快速打印log</a>
					<div>
						&quot; zsl_log.vim&quot; Version: 1.0 if exists(&quot;g:zsl_loaded_log&quot;) || &amp;cp || v:versio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7a1D4.html" rel="bookmark" class="title">Lightoj  1044 - Palindrome Partitioning &lpar;DP&rpar;</a>
					<div>
						题目链接: Lightoj  1044 - Palindrome Partitioning 题目描述: 给一个字符串,问至少分割多少次?分割出来的子串都是回文串. 解题思路: 先把给定串的所有子串是不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOlly0.html" rel="bookmark" class="title">monit 监控</a>
					<div>
						url http://mmonit.com/monit/documentation/monit.html Version 5.12 NAME SYNOPSIS DESCRIPTION WHAT TO  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QjmZeM.html" rel="bookmark" class="title">unity常用的比较函数</a>
					<div>
						1.Step(a,x):如果x&lt;a返回0:如果x&gt;或=a返回1 2.Clamp(x,a,b):如果x&lt;a返回a:如果x&gt;b返回b:如果在a和b之间就返回x 3.smoothst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnvjK0.html" rel="bookmark" class="title">配置数据库</a>
					<div>
						1:配置web.config &lt;appSettings&gt;&lt;!-- 连接字符串是否加密 --&gt;&lt;add key=&quot;ConStringEncrypt&quot; v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyP5rM.html" rel="bookmark" class="title">ProbCog&lbrack;github&rsqb;使用心得</a>
					<div>
						1. After installing ProbCog,you can run blnquery and mlnquery. If the terminal warns that 'command n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YQQAN0.html" rel="bookmark" class="title">c&plus;&plus;谭浩强教材教学练习例题1&period;2 求两数之和 为什么sum&equals;a&plus;b&semi;sum的值为65538</a>
					<div>
						第一章 #include &lt;iostream&gt;using namespace std; int main(){ int a,b,sum; sum=a+b; cin&gt;&gt;a&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d2KRz4.html" rel="bookmark" class="title">1高并发server：多路IO之select</a>
					<div>
						?? 1 select A:select能监听的文件描写叙述符个数受限于FD_SETSIZE,一般为1024.单纯改变进程打开 的文件描写叙述符个数并不能改变select监听文件个数 B:解决1024 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmW8VM.html" rel="bookmark" class="title">打造自己的移动绿色版 Python 环境</a>
					<div>
						本文只适用 Windows 系统,Linux,Mac 或其他系统可以直接自己写个脚本安装就好了,甚至大部分系统自带. 相信某些人写好了Python程序结果给朋友运行又得装个Python环境,难免失去了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l9QjW3.html" rel="bookmark" class="title">统计solr multivalued 字段中数目</a>
					<div>
						问题是这样的:已有若干multivalued 字段, 需要统计出 multivalued 字段中数目. 比如 *DOC1* &lt;doc&gt; &lt;arr name=&quot;multi&q ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
